Core - Bug # 61276

Status: Resolved Priority: Must have

Author: Roland Waldner Category: FormEngine aka TCEforms
Created: 2014-08-29 Assigned To:

Updated: 2014-09-05 Due date:

TYPO3 Version: 6.2

PHP Version: 53

Complexity: no-brainer

Is Regression: Yes

Sprint Focus:

Subject:

TCA property "exclusiveKeys" prevents from selecting an item

Description

In the TYPOS backend the TCA property "exclusiveKeys" of column type "select" prevents a backend user from selecting an item if
only one key is set.

It expects a string (list of) but only works if it is set to at least two keys seperated by a comma.

- works: 'exclusiveKeys' => '-1,-999'
- does not work: 'exclusiveKeys' => '-1'

"Does not work" means that no item can be selected at all - a JavaScript error is thrown instead.

Enclosed please find a screenshot of the error message the Chrome developer tools show.

Related issues:

related to Core - Task # 46357: Move TCEForms JS Code to external file - part 1 Resolved 2013-03-16

Associated revisions

Revision a869cd3a - 2014-09-05 14:38 - Roland Waldner

[BUGFIX] Make TCA property "exclusiveKeys" work with single key

It is necessary that "exclusiveValues" is a string in the JavaScript
method FormEngine.setSelectOptionFromExternalSource() because
in JavaScript strings (but not numbers) have a method match() which
is used in FormEngine.setSelectOptionFromExternalSource().

"exclusiveValues" representing a single key (e.g. -1) are of type
"Number" - in this case an JavaScript error is thrown when the
script calls match() on it.

This commit ensures that "exclusiveValues" is always casted to
String.

Resolves: #61276

Releases: 6.3, 6.2

Change-Id: 1049a5e6d11b3b27be901baal1e00429ab200b9a04
Reviewed-on: http://review.typo3.0rg/32591

Reviewed-by: Markus Klein <klein.t3@reelworx.at>

Tested-by: Markus Klein <klein.t3@reelworx.at>
Revision a4d88d1f - 2014-09-05 14:38 - Roland Waldner

[BUGFIX] Make TCA property "exclusiveKeys" work with single key

It is necessary that "exclusiveValues" is a string in the JavaScript
method FormEngine.setSelectOptionFromExternalSource() because
in JavaScript strings (but not numbers) have a method match() which
is used in FormEngine.setSelectOptionFromExternalSource().

"exclusiveValues" representing a single key (e.g. -1) are of type
"Number" - in this case an JavaScript error is thrown when the
script calls match() on it.

This commit ensures that "exclusiveValues" is always casted to
String.

Resolves: #61276

Releases: 6.3, 6.2

Change-Id: 1049a5e6d11b3b27be901baa1e00429ab200b9a04
Reviewed-on: http://review.typo3.org/32600

Reviewed-by: Markus Klein <klein.t3@reelworx.at>

Tested-by: Markus Klein <klein.t3@reelworx.at>

History

#1 - 2014-08-29 20:11 - Roland Waldner

This Bug seems to be introduced with TYPO3 6.2 - worked with TYPO3 6.1.? before.

#2 - 2014-09-01 14:35 - Markus Klein

Which variable is undefined in the screenshot?

The related change is https:/review.typo3.org/18971

But the code seems to be a 1:1 copy of the previous code, except that the configuration (incl. excludedKeys) are now handed over to JS via data-*

attributes.

#3 - 2014-09-01 19:44 - Roland Waldner

Markus Klein wrote:

Which variable is undefined in the screenshot?

Sorry, | am not able to check this before the upcomming weekend.

#4 - 2014-09-01 20:30 - Markus Klein

- Status changed from New to Needs Feedback
#5 - 2014-09-04 23:35 - Gerrit Code Review

- Status changed from Needs Feedback to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/32591

#6 - 2014-09-04 23:38 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/32591

#7 - 2014-09-05 00:23 - Markus Klein
- Complexity set to no-brainer

- Is Regression changed from No to Yes

#8 - 2014-09-05 14:38 - Gerrit Code Review

Patch set 1 for branch TYPO3_6-2 of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.org/32600

#9 - 2014-09-05 15:00 - Roland Waldner
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:a869cd3abef520c13837af386b3ec5149d39deb5a.
